#include "utils.PRO2"
#include "Arbre.hpp"
#include "ArbIOint.hpp"

Arbre<int> simetric(Arbre<int>& a)
/* Pre: a=A */
{
  Arbre<int> b;
  if (not a.es_buit()) {
    int n=a.arrel();
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    Arbre<int> b1=simetric(a1);
    //HI1: b1 és l'arbre simètric del fill esquerra d'A
    Arbre<int> b2=simetric(a2);
    //HI2: b2 és l'arbre simètric del fill dret d'A
    b.plantar(n,b2,b1);
  }
  /* Post1: b és l'arbre simètric d'A; a és buit */
  return b;
}
/* Post: retorna l'arbre simètric d'A */


/* Justificació

1) Cas senzill.

   Si A és buit llavors el simètric és l'arbre buit.

2) Cas recursiu.

   Si l'arbre no és buit té fill esquerra i fill dret, i el seu
   simètric té la mateixa arrel, com a fill esquerra el simètric del
   fill dret d'A, que per inducció (HI2) tenim a b2, i com a fill dret
   el simètric del fill esquerra d'A, que per inducció (HI1) tenim a
   b1.

3) Acabament.  

   Decreix el tamany d'a, ja que tan a1 com a2 tenen com a mínim un
   node menys.

 */


int main(){
  Arbre<int> a;
  llegir_arbre_int(a,0);
  Arbre<int> b=simetric(a);
  escriure_arbre_int(b);
  cout << endl;
}



